CF733C Epidemic in Monstropolis[模拟 构造 贪心]

时间:2021-09-10 23:44:58
C. Epidemic in Monstropolis
time limit per test

1 second

memory limit per test

256 megabytes

input

standard input

output

standard output

There was an epidemic in Monstropolis and all monsters became sick. To recover, all monsters lined up in queue for an appointment to the only doctor in the city.

Soon, monsters became hungry and began to eat each other.

One monster can eat other monster if its weight is strictly greater than the weight of the monster being eaten, and they stand in the queue next to each other. Monsters eat each other instantly. There are no monsters which are being eaten at the same moment. After the monsterA eats the monster B, the weight of the monster A increases by the weight of the eaten monster B. In result of such eating the length of the queue decreases by one, all monsters after the eaten one step forward so that there is no empty places in the queue again. A monster can eat several monsters one after another. Initially there were n monsters in the queue, the i-th of which had weight ai.

For example, if weights are [1, 2, 2, 2, 1, 2] (in order of queue, monsters are numbered from 1 to 6 from left to right) then some of the options are:

  1. the first monster can't eat the second monster because a1 = 1 is not greater than a2 = 2;
  2. the second monster can't eat the third monster because a2 = 2 is not greater than a3 = 2;
  3. the second monster can't eat the fifth monster because they are not neighbors;
  4. the second monster can eat the first monster, the queue will be transformed to [3, 2, 2, 1, 2].

After some time, someone said a good joke and all monsters recovered. At that moment there were k (k ≤ n) monsters in the queue, the j-th of which had weight bj. Both sequences (a and b) contain the weights of the monsters in the order from the first to the last.

You are required to provide one of the possible orders of eating monsters which led to the current queue, or to determine that this could not happen. Assume that the doctor didn't make any appointments while monsters were eating each other.

Input

The first line contains single integer n (1 ≤ n ≤ 500) — the number of monsters in the initial queue.

The second line contains n integers a1, a2, ..., an (1 ≤ ai ≤ 106) — the initial weights of the monsters.

The third line contains single integer k (1 ≤ k ≤ n) — the number of monsters in the queue after the joke.

The fourth line contains k integers b1, b2, ..., bk (1 ≤ bj ≤ 5·108) — the weights of the monsters after the joke.

Monsters are listed in the order from the beginning of the queue to the end.

Output

In case if no actions could lead to the final queue, print "NO" (without quotes) in the only line.

Otherwise print "YES" (without quotes) in the first line. In the next n - k lines print actions in the chronological order. In each line print x — the index number of the monster in the current queue which eats and, separated by space, the symbol 'L' if the monster which stays the x-th in the queue eats the monster in front of him, or 'R' if the monster which stays the x-th in the queue eats the monster behind him. After each eating the queue is enumerated again.

When one monster eats another the queue decreases. If there are several answers, print any of them.

Examples
input
6
1 2 2 2 1 2
2
5 5
output
YES
2 L
1 R
4 L
3 L
input
5
1 2 3 4 5
1
15
output
YES
5 L
4 L
3 L
2 L
input
5
1 1 1 3 3
3
2 1 6
output
NO
Note

In the first example, initially there were n = 6 monsters, their weights are [1, 2, 2, 2, 1, 2] (in order of queue from the first monster to the last monster). The final queue should be [5, 5]. The following sequence of eatings leads to the final queue:

  • the second monster eats the monster to the left (i.e. the first monster), queue becomes [3, 2, 2, 1, 2];
  • the first monster (note, it was the second on the previous step) eats the monster to the right (i.e. the second monster), queue becomes[5, 2, 1, 2];
  • the fourth monster eats the mosnter to the left (i.e. the third monster), queue becomes [5, 2, 3];
  • the finally, the third monster eats the monster to the left (i.e. the second monster), queue becomes [5, 5].

Note that for each step the output contains numbers of the monsters in their current order in the queue.


题意:相邻的数值不同可以互相吃,吃掉后数值相加,编号重新排,问能不能从a序列吃成b序列,并输出一个吃的顺序


官方题解:

The key observation to solution is to notice that b1 is union (monsters eat one another one by one in such a way that only one is being left) of elements of some prefix of a. And if you remove this prefix and first element of b then this condition will remain true for new arraysa and b.

Answer is "NO" when:

  • There is no such prefix that has sum of bi.
  • Prefix of sum bi consists of equal elements and its size  > 1.

Now let's consider certain prefix. Our goal is to find sequence of moves to get only one monster left.

Here is one of possible solutions:

  1. Find such i that ai is maximum in prefix and either ai - 1 or ai + 1 is strictly less that ai.
  2. Eat any of possible neighbors.
  3. If only one monster is left then move to next segment.
  4. If all weights become equal then print "NO".

The only thing left is to carefully calculate real positions of monsters on each step.

Also you can't output them at a moment of calculation as there might be a "NO" answer afterwards.

Time complexity — O(n2).

其实就是发现当前b首是由a的一个前缀和组成的,对于每个b[i]找a的一段然后打印就行了

打印时贪心选择最大的然后吃就行了,吃到剩下一个

对于前缀和不能相同的处理print已经保证了

需要注意最后a还剩下一些

感觉写起来挺顺利的,一些情况也想到怎么处理了

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstring>
#include <cmath>
using namespace std;
const int N=,INF=1e9+;
inline int read(){
char c=getchar();int x=,f=;
while(c<''||c>''){if(c=='-')f=-;c=getchar();}
while(c>=''&&c<=''){x=x*+c-'';c=getchar();}
return x*f;
}
int n,a[N],s[N],m,b[N];
int t[N];
struct eat{
int id;
char s;
}ans[N];
int cnt=,fail=;
void print(int n,int a[],int id){//printf("print %d %d\n",n,id);
while(n>){
int mx=-,p=-;
for(int i=;i<=n;i++)
if(a[i]>mx&& ((i!=&&a[i-]<a[i]) || (i!=n&&a[i+]<a[i])) ) mx=a[i],p=i;
if(p==-){fail=;return;} cnt++;ans[cnt].id=id+p;
if(p!=&&a[p-]<a[p]){
ans[cnt].s='L';
a[p-]+=a[p];n--;
for(int i=p;i<=n;i++) a[i]=a[i+];
}else{
ans[cnt].s='R';
a[p]+=a[p+];n--;
for(int i=p+;i<=n;i++) a[i]=a[i+];
}
}
}
void sol(){
for(int i=;i<=n;i++) s[i]=s[i-]+a[i]; int j=;
for(int i=;i<=m;i++){//printf("sol i %d\n",i);
int s=,p=;
for(j++;j<=n;j++){//printf("sol j %d\n",j);
s+=a[j];t[++p]=a[j];
if(s>=b[i]) break;
}
if(s!=b[i]){printf("NO");return;} print(p,t,i-);
if(fail){printf("NO");return;}
}
if(j<n) {puts("NO");return;}//! puts("YES");
for(int i=;i<=cnt;i++) printf("%d %c\n",ans[i].id,ans[i].s);
}
int main(){
n=read();
for(int i=;i<=n;i++) a[i]=read();
m=read();
for(int i=;i<=m;i++) b[i]=read();
sol();
}